if ('undefined' == typeof SothinkFlashDownloader) {
	SothinkFlashDownloader = {};
}
SothinkFlashDownloader.Parse = (function() {
	function $() {
		return document.getElementById(arguments[0]);
	}
	return {
		validateURLs: [],
		validateexts: [],
		webdeveloper_getDocuments: function(frame, documentList) {
			var framesList = frame.frames;
			documentList.push(frame.document);
			for (var i = 0; i < framesList.length; i++) {
				SothinkFlashDownloader.Parse.webdeveloper_getDocuments(framesList[i], documentList);
			}
			return documentList;
		},
		initWeb: function() {
			while (this.validateURLs.length) {
				this.validateURLs.pop();
			}
			while (this.validateexts.length) {
				this.validateexts.pop();
			}
			this.validateexts.push('swf', 'asp', 'jsp', 'php');
		},
		doWebParse: function() {
			SothinkFlashDownloader.Parse.initWeb();
			var docs = SothinkFlashDownloader.Parse.webdeveloper_getDocuments(window.parent.content, []);
			for (var j = 0; j < docs.length; j++) {
				var embeds = docs[j].getElementsByTagName("embed");
				for(var m = 0; m < embeds.length; m++){
				    if(embeds[m].parentNode.nodeName.toUpperCase() != "OBJECT")
				    {
					var url = window.parent.makeURLAbsolute(docs[j].baseURI, embeds[m].src);
					SothinkFlashDownloader.Parse.saveRightURL(url);
				    }
				}
				
				var objects = docs[j].getElementsByTagName("object");
				for (var k = 0; k < objects.length; k++) {
					if(objects[k].data){
						var url = window.parent.makeURLAbsolute(docs[j].baseURI, objects[k].data);
						SothinkFlashDownloader.Parse.saveRightURL(url);
					}else{
						var obj = objects[k].getElementsByTagName("embed")[0];
						var url = window.parent.makeURLAbsolute(docs[j].baseURI, obj.src);
						SothinkFlashDownloader.Parse.saveRightURL(url);
					}
					
				}
					
				//var anchors = docs[j].getElementsByTagName("a");
				//for (var m = 0; m < anchors.length; m++) {
				//	var url = window.parent.makeURLAbsolute(docs[j].baseURI, anchors[m].href);
				//	SothinkFlashDownloader.Parse.saveRightURL2(url);
				//}
			}
			if (this.validateURLs.length == 0) {
				$('my-tree').focus();
				$('my-tree').view = null;
				return;
			}
			SothinkFlashDownloader.Tree.reflectTreeBuild();
		},
		testContain: function(strContainer, strSub) {
			var sublen = strSub.length;
			var conlen = strContainer.length;
			if (conlen - sublen < 0) {
				return false;
			}
			for (var i = 0; i <= conlen - sublen; i++) {
				if (strContainer.substring(i, i + sublen) === strSub) return true;
			}
			return false;
		},
		saveRightURL: function(url) {
			var URLArray = this.validateURLs,
				extArray = this.validateexts,
				testContain = this.testContain;
				
			try {
				var myurl = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURL);
				myurl.spec = url;
				var fileext = myurl.fileExtension;
				var match = false;

				for (var i = extArray.length - 1; i >= 0; i--) {
					if (extArray[i] == fileext) {
						if (testContain(url, ".swf") || (testContain(url, "swf") && testContain(url, fileext + "?"))) {
							match = true;
							break;
						}
					}
				}
				if (!match) {
					//return;
				}
				for (i = URLArray.length - 1; i >= 0; i--) {
					if (URLArray[i] == url) {
						return;
					}
				}
				URLArray.push(url);
			} catch(e) {
				alert(e);
			}
		},
		saveRightURL2: function(url) {
			var URLArray = this.validateURLs,
			extArray = this.validateexts,
			testContain = this.testContain;
			try {
				if (testContain(url, "javascript:")) {
					return;
				}
				var myurl = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURL);
				myurl.spec = url;
				var fileext = myurl.fileExtension;

				if (fileext == "swf") {
					URLArray.push(url);
				}
			} catch(e) {
				alert(e);
			}
		}
	};
})();