if ('undefined' == typeof SothinkFlashDownloader) {
	SothinkFlashDownloader = {};
}    
SothinkFlashDownloader.curSel = [];
SothinkFlashDownloader.Right = (function() {
	function $() {
		return document.getElementById(arguments[0]);
	}
	return {
		getCurSelection: function() {
			while (SothinkFlashDownloader.curSel.length) {
				SothinkFlashDownloader.curSel.pop();
			}
			var tree = $('my-tree');
			for (var i = 0; i < SothinkFlashDownloader.objArray.length; i++) {
				if (tree.view.selection.isSelected(i)) SothinkFlashDownloader.curSel.push(SothinkFlashDownloader.objArray[i]);
			}
		},
		doShowProperty: function() {
			SothinkFlashDownloader.Right.getCurSelection();
			if (SothinkFlashDownloader.curSel.length <= 0 || (SothinkFlashDownloader.curSel.length > 0 && SothinkFlashDownloader.curSel[0].url == null)) {
				alert("please select a file.");
				return;
			}
			window.openDialog("chrome://swfcatcher/content/property.xul", "_new", "chrome,resizable,modal,width=500,height=200,centerscreen");
		},
		getDownloadFile: function(swfname, defaultSaveSWFDir, fileFilter) {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window, "Save As", nsIFilePicker.modeSave);
			fp.defaultString = swfname;

			var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			localFile.initWithPath(defaultSaveSWFDir);

			fp.displayDirectory = localFile;
			fp.appendFilter(fileFilter, "*." + fileFilter);

			var rv = fp.show();
			if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
				var file = fp.file;
				var path = fp.file.path;
				return file;
			}
			return null;
		},
		doSaveas: function() {
			SothinkFlashDownloader.Right.getCurSelection();

			if (SothinkFlashDownloader.curSel.length == 1 && SothinkFlashDownloader.curSel[0].url != null) {
				/*
						if (SothinkFlashDownloader.curSel[0].alive == false) {
							alert("bad link or target file does not exsit.");
							return;
						}
						*/
				var swfUrl = SothinkFlashDownloader.curSel[0].url;

				//if (SothinkFlashDownloader.Overlay.IsWindowPlatform()) {
					var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.swfcatcher.");
					var defaultPath = null;
					if (objectionPrefs.getCharPref("path_default") == "null") {
					    var dirService = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
					    var tempDirFile = dirService.get("Desk", Components.interfaces.nsIFile);
					    defaultPath = tempDirFile.path;
					} else defaultPath = decodeURIComponent(escape(objectionPrefs.getCharPref("path_default")));
		
					var file = SothinkFlashDownloader.Right.getDownloadFile(SothinkFlashDownloader.curSel[0].name, defaultPath, "swf");
					var persist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);
					var ios = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
					var uri = ios.newURI(swfUrl, null, null);
					if (!file) {
						return;
					}
					var target = ios.newFileURI(file);
					var xfer = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);
					xfer.init(uri, target, "", null, null, null, persist, null);
					persist.progressListener = xfer;
					persist.saveURI(uri, null, null, null, null, file, null);
				//} else {
				//	window.parent.saveURL(swfUrl, SothinkFlashDownloader.curSel[0].name);
				//}
			} else {
				alert("please select a file.")
			}
		},
		doPreview: function() {
			SothinkFlashDownloader.Right.getCurSelection();
			if (SothinkFlashDownloader.curSel.length) {
				for (var j = 0; j < SothinkFlashDownloader.curSel.length; j++) {
					window.parent.openNewTabWith(SothinkFlashDownloader.curSel[j].url);
				}
			} else {
				alert("please select a file.")
			}
		},
		doBatchsave: function() {
			SothinkFlashDownloader.Right.getCurSelection();

			if (SothinkFlashDownloader.curSel.length <= 0 || (SothinkFlashDownloader.curSel.length > 0 && SothinkFlashDownloader.curSel[0].url == null)) {
				alert("please select a file.")
			}

			for (var temp = 0; temp < SothinkFlashDownloader.curSel.length; temp++) {
				var urltemp = SothinkFlashDownloader.objArray[temp]["url"];
				if (urltemp.substring(0, 7) === "http://") {
					window.parent.saveURL(urltemp, null, null, true, true, null);
				} else if (urltemp.substring(0, 7) === "file://") {
					window.parent.saveURL(urltemp, null, null, true, true, null);
				} else {}
			}

			//open only one download manager window
			window.openDialog("chrome://mozapps/content/downloads/downloads.xul", "_new", "chrome,centerscreen");
		},
		doViewlocation: function() {
			if (SothinkFlashDownloader.objArray.length == 0) return;
			SothinkFlashDownloader.Right.getCurSelection();

			if (SothinkFlashDownloader.curSel.length == 1 && SothinkFlashDownloader.curSel[0].url != null) {
				SothinkFlashDownloader.Parse.initWeb();
				docs = SothinkFlashDownloader.Parse.webdeveloper_getDocuments(window.parent.content, []); //仍然用递归的方式解析web页面

				for (j = 0; j < docs.length; j++) {
					var x = docs[j];

					//target is marked with red blinking rectangle 
					var objects = x.getElementsByTagName("object");
					for (var i = 0; i < objects.length; i++) {
						if(objects[i].data){
							if (window.parent.makeURLAbsolute(docs[j].baseURI, objects[i].data) == SothinkFlashDownloader.curSel[0].url) {
								objects[i].scrollIntoView(true);
								objects[i].parentNode.scrollIntoView(true);
								var flasher1 = new SothinkFlashDownloader.Flasher("#CC0000", 3, 2000, 100, false);
								flasher1.element = objects[i];
								flasher1.start();
								return;
							}
						}else{
							var obj = objects[i].getElementsByTagName("embed")[0];
							if (window.parent.makeURLAbsolute(docs[j].baseURI, obj.src) == SothinkFlashDownloader.curSel[0].url) {
								obj.scrollIntoView(true);
								obj.parentNode.scrollIntoView(true);
								var flasher1 = new SothinkFlashDownloader.Flasher("#CC0000", 3, 2000, 100, false);
								flasher1.element = obj;
								flasher1.start();
								return;
							}
						}
					}
					
					var embeds = x.getElementsByTagName("embed");
					for(var k = 0; k < embeds.length; k++){
					    if(embeds[k].parentNode.nodeName.toUpperCase() != "OBJECT")
					    {
						if (window.parent.makeURLAbsolute(docs[j].baseURI, embeds[k].src) == SothinkFlashDownloader.curSel[0].url) {
							embeds[k].scrollIntoView(true);
							embeds[k].parentNode.scrollIntoView(true);
							var flasher1 = new SothinkFlashDownloader.Flasher("#CC0000", 3, 2000, 100, false);
							flasher1.element = embeds[k];
							flasher1.start();
							return;
						}
					    }
					}
					//var embeds = x.getElementsByTagName("embed");
					//for (var i = 0; i < embeds.length; i++) {
					//	if (window.parent.makeURLAbsolute(docs[j].baseURI, embeds[i].src) == SothinkFlashDownloader.curSel[0].url) {
					//		embeds[i].scrollIntoView(true);
					//		embeds[i].parentNode.scrollIntoView(true);
					//		var flasher1 = new SothinkFlashDownloader.Flasher("#CC0000", 3, 2000, 100, false);
					//		flasher1.element = embeds[i];
					//		flasher1.start();
					//		return;
					//	}
					//}
					
					var links = x.getElementsByTagName("a");
					for (var i = 0; i < links.length; i++) {
						if (window.parent.makeURLAbsolute(docs[j].baseURI, links[i].href) == SothinkFlashDownloader.curSel[0].url) {
							links[i].scrollIntoView(true);
							var flasher2 = new SothinkFlashDownloader.Flasher("#CC0000", 2, 2000, 100, false);
							flasher2.element = links[i];
							flasher2.start();
							return;
						}
					}
				}
			} else {
				alert("please select a file.")
			}
		},
		processRelativePath: function(pathRelative) {
			var a = pathRelative;
			while (a.lastIndexOf("\\") > 0) {
				a = a.replace("\\", "/");
			}
			return a;
		}
	};
})();